/* ServerMark Agent TCP/IP interface
   setup_ServerMark_Agent.sh will setup everything(including driver & interface) */

/* library for TCP/IP */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <unistd.h>
#include <arpa/inet.h>

#define MAXLINE    80	//define message's max length

int tcp_connect(int af, char *servip, unsigned short port);	//connecting function to Administrator
void errquit(char *mesg) { perror(mesg); exit(1); }	//error quit at select fuction

int TRACE_DEV;	//file descriptor for the driver file 



int main(int argc, char *argv[]) {
    
    char bufall[MAXLINE];	//message buffer from server
    char buf[MAXLINE];
		unsigned int size = 0;
    int maxfdp1,		    	// max socket descriptor
       s;          		 		// server socket No
    fd_set read_fds;			// enable read_fds

    if(argc != 3) {
        printf("Usage : %s sever_ip port \n", argv[0]);
        exit(0);
    }
    
    s = tcp_connect(AF_INET, argv[1], atoi(argv[2]));
    if(s==-1)
        errquit("REP : TCP connect to administrator fail\n");
    puts("REP : Connected to Administrator\n");
    maxfdp1 = s + 1;

		TRACE_DEV = open("/dev/pmutrace", O_RDWR);
		if(TRACE_DEV <0)
			{
				printf("REP : Could not open /dev/pmutrace, exiting\n");
				exit(1);
			}

    while(1) 
    {
    		FD_ZERO(&read_fds);	//init read_fds value
        FD_SET(s, &read_fds);
        FD_SET(TRACE_DEV, &read_fds);
        
        if(select(maxfdp1, &read_fds, NULL,NULL,NULL) < 0)
             errquit("Select fail");
 
        if (FD_ISSET(s, &read_fds)) //if received any messages from administrator
        	{
        		 printf("DEBUG : FD_ISSET from S\n");
             int nbyte;
             if ((nbyte = recv(s, bufall, MAXLINE, 0)) > 0) 
             	{
                 bufall[nbyte] = 0;
                 printf("%s \n", bufall);
                 //message parsing
                 //DVFS change message
                 if(strstr(bufall,"serv_dvfs_"))
                 	{
                 		printf("serv_dvfs_ -> %s\n",bufall);
                 	}
                 //request for performance event values
                 if(strstr(bufall,"serv_eventval"))	
                 	{
                 		printf("request event value\n");
                 		read(TRACE_DEV, buf, MAXLINE);
                 		send(s,buf,sizeof(buf),0);
                 	}
                 	
                 //message for change monitored event	
                 else if(strstr(bufall,"serv_event_membus"))
                 	{
                 		ioctl(TRACE_DEV,event_membus);
                 		printf("serv_event -> %s\n",bufall);
                	}
                 
                 else if(strstr(bufall,"serv_event_L2miss"))
                 	{
                 		ioctl(TRACE_DEV,event_l2miss);
                 		printf("serv_event -> %s\n",bufall);
                	}
                 else if(strstr(bufall,"serv_event_Mispred"))
                 	{
                 		ioctl(TRACE_DEV,event_mispred);
                 		printf("serv_event -> %s\n",bufall);
                	}	
                	
                 //message for change dvfs
                 else if(strstr(bufall,"serv_perf_50"))
                 	{
                 		ioctl(TRACE_DEV,perf_50);
                 		printf("serv_perf_percentage -> %s\n",bufall);
                 	}
                 	
                 else if(strstr(bufall,"serv_perf_70"))
                 	{
                 		ioctl(TRACE_DEV,perf_70);
                 		printf("serv_perf_percentage -> %s\n",bufall);
                 	}	
                 
                 else if(strstr(bufall,"serv_perf_auto"))
                 	{
                 		ioctl(TRACE_DEV,perf_auto);
                 		printf("serv_perf_percentage -> %s\n",bufall);
                 	}	
                 		
                 else if(strstr(bufall,"serv_request"))
                 	{
                 		//resuest CPU info--> Not implemented
                 	}
             	}
        	}
        if (FD_ISSET(TRACE_DEV, &read_fds))	//if received any messages from driver
        	{
        		int nbyte;
        		printf("TRACE_DEV_FDISEST\n");
        		if ((nbyte = read(s, bufdrv, MAXLINE)) > 0) 
             	{
                 bufdrv[nbyte] = 0;
                 printf("%s \n", bufdrv);
                 //message parsing
                 if(strstr(bufdrv,"client_event1"))
                 	{
                 		//1 ̺Ʈ  ۽  ʿ
                 		printf("client_event1 -> %s\n",bufdrv);
                 	}
                 else if(strstr(bufall,"client_event2"))
                 	{
                 		//2 ̺Ʈ  ۽  ʿ
                 		printf("client_event2 -> %s\n",bufdrv);
                	}
                 else if(strstr(bufall,"client_response_cpuinfo"))
                 	{
                 		//CPU  ۽  ʿ-->  
                 	}
             	} 
        	}
    }// end of while

}//end of main function


int tcp_connect(int af, char *servip, unsigned short port) {
    struct sockaddr_in servaddr;
    int s;
    if ((s = socket(af, SOCK_STREAM, 0)) < 0)	//create socket
        return -1;
        
    //init struct server address 
    bzero((char *)&servaddr, sizeof(servaddr));	
    servaddr.sin_family = af;
    inet_pton(AF_INET, servip, &servaddr.sin_addr);
    servaddr.sin_port = htons(port);
    
    //request connect function
    if(connect(s, (struct sockaddr *)&servaddr, sizeof(servaddr))	< 0)	
        return -1;
    return s;
}
